<template>
  <div v-show="checkIsFavourite(gameData.GameId)"
    :class="['favourite-no-animation overflow-hidden', `colorFade-${gameData.GameId}`]">
      <SvgIcon id="active-favourite" @click.stop="authenticated ?  setAndUnsetGameToFavourite(gameData, false, index) : checkRedirectToLoginOrToggleDialog()"
        :class-name="[`scale-animation-${gameData.GameId}`, 'h-[18.33px] w-[20px]']"
        svg-name="icon-heart"/>
  </div>
  <IconFavorite
    v-show="!checkIsFavourite(gameData.GameId)"
    id="inactive-favourite"
    class="text-white"
    :class="['favourite-animation']"
    @click.stop="
      authenticated
        ? setAndUnsetGameToFavourite(gameData, true, index)
        : checkRedirectToLoginOrToggleDialog()
    "
  />
  <!-- <SvgIcon v-show="!checkIsFavourite(gameData.GameId)"
    @click.stop="authenticated ? setAndUnsetGameToFavourite(gameData, true, index) : checkRedirectToLoginOrToggleDialog()"
    :class-name="['favourite-animation', {'opacity-0' : !ForMobile}]" svg-name="icon-favourite" id="inactive-favourite"
    /> -->
</template>

<script lang="ts" setup>
import { PropType } from "vue";
import { GameBsi } from "@/models/bsiGameList";
import { store } from "~~/store";
import IconFavorite from "~/assets/icons/favorite.svg?component";

const authenticated = computed(() => store.state.auth);

const props = defineProps({
  gameData: {
    type: Object as PropType<GameBsi>
  },
  checkIsFavourite: {
    type: Function,
    required: true,
  },
  setAndUnsetGameToFavourite: {
    type: Function,
    required: true,
  },
  redirectToLogin: {
    type: Function,
    required: true,
  },
  ForMobile: {
    type: Boolean,
    default: false,
  },
  toggleDialog: {
    type: Boolean,
    default: false,
  },
});
let wasFavourite = props.checkIsFavourite(props.gameData?.GameId);
const { toggleLoginRegisterDialog } = commonHelper;
const checkRedirectToLoginOrToggleDialog = () => {
  return props.toggleDialog ? toggleLoginRegisterDialog() : props.redirectToLogin();
};
watch(
  () => props.checkIsFavourite(props.gameData?.GameId),
  (isFavourite) => {
    if (wasFavourite && !isFavourite) {
      const inactiveFavoriteIcons = document.querySelectorAll(
        ".favourite-animation"
      ) as NodeListOf<HTMLElement>;
      inactiveFavoriteIcons.forEach((inactiveFavoriteIcon) => {
        if (inactiveFavoriteIcon) {
          inactiveFavoriteIcon.style.animation = "none";
        }
      });
    }
    wasFavourite = isFavourite;
  }
);
</script>

<style lang="postcss">
.favourite-no-animation {
  @apply absolute top-[5px] right-[5px] h-[32px] w-[32px] z-20 rounded-md bg-[rgba(242,116,139,0.2)] items-center justify-center flex;
}
.favourite-animation {
  @apply absolute top-[5px] right-[5px] h-[32px] w-[32px] z-20 rounded-md;
}
@keyframes fadeInFromBottom {
  0% {
    opacity: 0;
    transform: translateY(100%);
  }
  100% {
    opacity: 1;
    transform: translateY(0);
  }
}
@keyframes fadeInFromTop {
  0% {
    opacity: 0;
    transform: translateY(-100%);
  }
  100% {
    opacity: 1;
    transform: translateY(0);
  }
}
@keyframes fadeOutToTop {
  0% {
    opacity: 0;
    transform: translateY(0);
  }
  100% {
    opacity: 1;
    transform: translateY(-120%);
  }
}
@keyframes scaleAnimation {
  0% {
    transform: scale(1);
  }
  50% {
    transform: scale(1.5);
  }
  100% {
    transform: scale(1);
  }
}
@keyframes fadeColor {
  0% {
    background: rgba(242, 116, 139, 1);
  }
  50% {
    background: rgba(242, 116, 139, 1);
  }
  100% {
    background: rgba(242, 116, 139, 0.2);
  }
}
.group:hover .play__now__content_for_animate {
  animation: fadeInFromBottom .5s ease-in-out;
}
.group:hover .favourite-animation {
  @apply opacity-100;
}
.colorFade {
  animation: fadeColor 2s ease-in-out forwards;
}
.scale-animation {
  animation-iteration-count: 1;
  animation: scaleAnimation 1s normal forwards ease-in-out;
}
</style>